<?php

class actionMypatchApply extends cmsAction {

    public function run(){
        $is_admin = cmsUser::isAdmin();
        if (!$is_admin) { cmsCore::error404(); }

        $mypatch_model = cmsCore::getModel('mypatch');
        
        $files = $mypatch_model->getAllPatchFiles();
        
        // создаем массив измененых файлов и их содержание
        $files_patch = $this->PatchingFiles($files);
        
        //сохраняем измененные файлы
        $mypatch_error = $mypatch_model->SavePatchFiles ($files_patch);
        // если при сохранении файлов были ошибки - идем разбираться
        if ($mypatch_error['ftp_auth'] == 1){
            cmsUser::addSessionMessage(LANG_MYPATCH_CP_FTP_AUTH_FAILED, 'error');
            $this->redirectToAction('');
        } elseif ($mypatch_error['file_patch_create']['cache_dir'] == 1){
            cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_CACHE, 'error');            
        } elseif ($mypatch_error['file_patch_create']['temp']){
            cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_PATCHFILE_TEMP, 'error');            
        } elseif ($mypatch_error['file_patch_create']['create']){
            cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_PATCHFILE_CREATE, 'error');            
        } else {
            // если все прошло успешно - радуемся - и отправляемся к спискам патчей. 
            cmsUser::addSessionMessage(LANG_MYPATCH_APPLY_OK, 'success');            
        }
        $this->redirectToAction('');
    }
    
    private function PatchingFiles($files) {
    $files_patch = array();
    $mypatch_model = cmsCore::getModel('mypatch');
    $config = cmsConfig::getInstance();

        foreach ($files as $file) {

            if ($file['state_patch'] >= 1 && $file['state_file'] >= 1){
                
                if (empty($files_patch[$file['file_original']])){
                    
                    if (!file_exists($config->root_path . $file['file_original'] . ".original")){
                        $code_in = file($config->root_path . $file['file_original']);    
                    } else {
                        $code_in = file($config->root_path . $file['file_original'] . ".original");
                    }
                                        
                } else {
                    $code_in = $files_patch[$file['file_original']];
                }
                
                $shifts = $mypatch_model->SearchShifts($code_in, $file['code_search']);
                if (empty($shifts) || count($shifts) > 1){
                    $mypatch_model->changeStatePatching ($file, $status = 'error');
                    cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_PATCHING, 'error');            
                    $this->redirectToAction('');
                }
                
                $files_patch[$file['file_original']] = $mypatch_model->ReplaceCode($code_in, $file['code_search'], $file['code_replace'], $shifts, $file['description']);
                $mypatch_model->changeStatePatching ($file, $status = 'success');
            }    
        }
    return $files_patch;   
    }
}    