<?php

class actionMypatchPatchDownload extends cmsAction {

        private $upload_name = 'patch';
        private $upload_exts = 'zip,patch';

        public function run($do=false){
        $is_admin = cmsUser::isAdmin();
        if (!$is_admin) { cmsCore::error404(); }

        $patch_name = $this->request->get('patch_name', $this->uploadPatch());
        $is_no_extract = $this->request->get('is_no_extract', false);

        if (!$is_no_extract && !$patch_name){return $this->showUploadForm();}

        $error = $this->AddLoadPatch($patch_name, $is_no_extract);
        
        if ($error['version'] == 1){
            cmsUser::addSessionMessage(LANG_MYPATCH_ERRORS_LOAD, 'error');
        }
        $this->redirectToAction('');
    }

    private function AddLoadPatch($patch_name, $is_no_extract=false){
        
        $config = cmsConfig::getInstance();
        $current_version = cmsCore::getVersion();
        
        if (!$is_no_extract) { $this->extractPackage($patch_name); }
        
        $dir = $config->upload_path . mypatch;
            $dirHandle = opendir($dir);
            while (false !== ($file = readdir($dirHandle))) {
                if ($file !== '.'){
                    if ($file !== '..'){
                        $error = $this-> PatchAddDB($dir. '/' . $file, $current_version, $error);
                    }
                }
            }

        
        return $error;
    }
    
    private function PatchAddDB($patchfile, $current_version, $error) {
        $mypatch_model = cmsCore::getModel('mypatch');
        $data_order = explode("[order_file]", @file_get_contents($patchfile));
        $data_version = explode("[description]", $data_order [0]);

        //проверка соответствия версий патча и системы
        $version = explode("[version]", $data_version [0]);
        $version = $version[1];
        $version = str_replace("\n","", $version);
        if ($version != $current_version){
        $error[version]=1;
        return $error;    
        }
        
        $patch[description] = $data_version[1];
        array_shift ($data_order);
        foreach ($data_order as $data){
                $str_original = explode("[file_original]",$data);
                $str_search = explode("[code_search]",$str_original[1]);
                $patch[$str_original[0]]['file_original'] = $str_search[0];
                $str_replace = explode("[code_replace]",$str_search[1]);
                $patch[$str_original[0]]['code_search'] = $str_replace[0];
                $patch[$str_original[0]]['code_replace'] = $str_replace[1];
                
        };
        
        $mypatch_model->LoadPatch($patch);
        return $error;
        
    }
    
    private function extractPackage($patch_name){

        $patch_name_info = pathinfo($patch_name);
        if ($patch_name_info['extension'] == "zip"){
            
            $config = cmsConfig::getInstance();    
            $zip_dir = $config->upload_path . mypatch;
            $zip_file =  $zip_dir . '/' . $patch_name;


            $zip = new ZipArchive();

            if (!$zip->open( $zip_file )){
                cmsUser::addSessionMessage(LANG_CP_INSTALL_ZIP_ERROR, 'error');
                $this->redirectBack();
            }

            $zip->extractTo($zip_dir);
            $zip->close();

            unlink($zip_file);
        }
        return true;
    }
    
    private function showUploadForm(){

        $errors = $this->checkErrors();
        return  cmsTemplate::getInstance()->render('backend/patch_down', array(
            'errors' => $errors,
        ));

    }

    private function checkErrors(){

        $config = cmsConfig::getInstance();

        $errors = array();

        if (!cmsCore::isWritable( $config->upload_path . mypatch )){
            $errors[] = array(
                'text' => sprintf(LANG_CP_INSTALL_NOT_WRITABLE, $config->upload_root . mypatch),
                'hint' => LANG_CP_INSTALL_NOT_WRITABLE_HINT,
                'fix' => LANG_CP_INSTALL_NOT_WRITABLE_FIX,
                'workaround' => sprintf(LANG_CP_INSTALL_NOT_WRITABLE_WA, $config->upload_root . mypatch)
            );
        }

        if (!class_exists('ZipArchive')){
            $errors[] = array(
                'text' => LANG_CP_INSTALL_NOT_ZIP,
                'hint' => LANG_CP_INSTALL_NOT_ZIP_HINT,
                'fix' => LANG_CP_INSTALL_NOT_ZIP_FIX,
                'workaround' => sprintf(LANG_CP_INSTALL_NOT_ZIP_WA, $config->upload_root . mypatch),
            );
        }

        return $errors ? $errors : false;

    }
   
    private function uploadPatch(){

        $config = cmsConfig::getInstance();
        
        $uploader = new cmsUploader();

        if (!$uploader->isUploaded( $this->upload_name )){ return false; }

          files_clear_directory($config->upload_path . mypatch);
        
        $result = $uploader->uploadForm($this->upload_name, $this->upload_exts, 0, "mypatch");        

        if (!$result['success']){
            cmsUser::addSessionMessage($result['error'], 'error');
            return false;
        }

        return $result['name'];

    }
    
    
}
